/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of QueryString.xs. Do not edit this file, edit QueryString.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Text/QueryString.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"
#include "xshelper.h"

STATIC_INLINE
SV *
decode_uri_component(SV *uri){
    SV *result;
    int slen, dlen;
    U8 buf[8], *dst, *src, *bp;
    int i, hi, lo;

    /* because of our usage, suri is guaranteed to be defined */
    /* if (suri == &PL_sv_undef) return newSV(0); */
    /* if (!SvPOK(suri)) return newSV(0); */
    /* because of our usage, it's okay to make possibly destructive calls */
    /*
    uri  = sv_2mortal(newSVsv(suri)); * make a copy to make func($1) work */
    slen = SvPOK(uri) ? SvCUR(uri) : 0;
    dlen = 0;
    result = newSV(slen + 1);
   
    SvPOK_on(result);
    dst  = (U8 *)SvPV_nolen(result);
    src  = (U8 *)SvPV_nolen(uri);

    for (i = 0; i < slen; i++){
    if (src[i] == '+'){
        dst[dlen++] = ' ';
    } else if (src[i] == '%'){
        if (isxdigit(src[i+1]) && isxdigit(src[i+2])){
        strncpy((char *)buf, (char *)(src + i + 1), 2);
        buf[2] = '\0'; /* @kazuho++ */
        hi = strtol((char *)buf, NULL, 16);
        dst[dlen++] = hi;
        i += 2;
        }
        else if(src[i+1] == 'u'
            && isxdigit(src[i+2]) && isxdigit(src[i+3])
            && isxdigit(src[i+4]) && isxdigit(src[i+5])){
        strncpy((char *)buf, (char *)(src + i + 2), 4);
        buf[4] = '\0'; /* RT#39135 */
        hi = strtol((char *)buf, NULL, 16);
        i += 5;
        if (hi < 0xD800  || 0xDFFF < hi){
            bp = uvchr_to_utf8((U8 *)buf, (UV)hi);
            strncpy((char *)(dst+dlen), (char *)buf, bp - buf);
            dlen += bp - buf;
        }else{
            if (0xDC00 <= hi){ /* invalid */
            warn("U+%04X is an invalid surrogate hi\n", hi);
            }else{
            i++;
            if(src[i] == '%' && src[i+1] == 'u'
               && isxdigit(src[i+2]) && isxdigit(src[i+3])
               && isxdigit(src[i+4]) && isxdigit(src[i+5])){
                strncpy((char *)buf, (char *)(src + i + 2), 4);
                lo = strtol((char *)buf, NULL, 16);
                i += 5;
                if (lo < 0xDC00 || 0xDFFF < lo){
                warn("U+%04X is an invalid lo surrogate", lo);
                }else{
                lo += 0x10000
                    + (hi - 0xD800) * 0x400 -  0xDC00;
                bp = uvchr_to_utf8((U8 *)buf, (UV)lo);
                strncpy((char *)(dst+dlen), (char *)buf, bp - buf);
                dlen += bp - buf;
                }
            }else{
                warn("lo surrogate is missing for U+%04X", hi);
            }
            }
        }
        }else{
        dst[dlen++] = '%';
        }
    }
    else{
        dst[dlen++] = src[i];
    }
    }

    dst[dlen] = '\0'; /*  for sure; */
    SvCUR_set(result, dlen);
    return result;
}

/* split on "=".
   *key contains the key, &key_len contains the length,
   *value contains the value, &valye_len contains the length.
   if "=" is not found, key = the string, value = ''
*/
STATIC_INLINE
void
split_kv(char *start, char *end, char **key, size_t *key_len, char **value, size_t *value_len) {
    char *cur = start;
    int found_eq = 0;
    while (cur != end) {
        if (*cur == '=') {
            found_eq = 1;
            *key = start;
            *key_len = cur - start;
            cur++;
            break;
        }
        cur++;
    }
    if (found_eq) {
        *value = cur;
        *value_len = end - cur;
    } else {
        *key = start;
        *key_len = end - start;
        *value_len = 0;
    }
}

#line 130 "lib/Text/QueryString.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 274 "lib/Text/QueryString.c"

XS_EUPXS(XS_Text__QueryString_parse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__QueryString_parse)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, qs");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	char *	qs = (char *)SvPV_nolen(ST(1))
;
#line 129 "lib/Text/QueryString.xs"
        char *cur = qs;
        char *prev = qs;
        char *key, *value;
        size_t key_len, value_len;
#line 294 "lib/Text/QueryString.c"
#line 134 "lib/Text/QueryString.xs"
        PERL_UNUSED_VAR(self);
        if (qs == NULL) { /* sanity */
            XSRETURN(0);
        }

        /* First, chop chop until end of string or & or ; */
        while (*cur != '\0') {
            if (*cur == '&' || *cur == ';') {
                /* found end of this pair. look for an = sign */
                split_kv(prev, cur, &key, &key_len, &value, &value_len);
                mXPUSHs(decode_uri_component(sv_2mortal(newSVpvn(key, key_len))));
                mXPUSHs(decode_uri_component(sv_2mortal(newSVpvn(value, value_len))));
                cur++;
                prev = cur;
            } else {
                cur++;
            }
        }

        /* do we have something leftover? */
        if (prev != cur) {
            split_kv(prev, cur, &key, &key_len, &value, &value_len);
            mXPUSHs(decode_uri_component(sv_2mortal(newSVpvn(key, key_len))));
            mXPUSHs(decode_uri_component(sv_2mortal(newSVpvn(value, value_len))));
        }
#line 321 "lib/Text/QueryString.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Text__QueryString); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Text__QueryString)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Text::QueryString::parse", XS_Text__QueryString_parse);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
